#!/system/bin/sh

#This is a simple script which allows the user to create .odex files to
#"optimize" dalvik 

# Decad3nce<abegovic@huskers.unl.edu>
# :D

# ---
odexfilesframework=/system/framework/core.odex;
odexfiles=/system/app/Phone.odex;

# Delete dalvik-cache
echo "Clearing dalvik-cache";
rm /data/dalvik-cache/*;

dexopt_core()
{
if [ -f "$odexfiles" ]
	then
		echo "Decad3nce Dexopt: .odex files present in /system/app, exiting";
		exit;
	else if [ -f "$odexfilesframework" ]
		then	
			echo "system/framework already has .odex files, exiting";
			exit
			else
				echo "Decad3nce Dexopt: dexopt-wrapper on framework core java archives, do not interrupt";
				dexopt-wrapper /system/framework/core.jar /system/framework/core.odex;
				dexopt-wrapper /system/framework/ext.jar /system/framework/ext.odex;
				dexopt-wrapper /system/framework/android.policy.jar /system/framework/android.policy.odex;
				dexopt-wrapper /system/framework/services.jar /system/framework/services.odex;
			fi
fi
}

dexopt_system()
{
if [ -f "$odexfiles" ]
	then
		echo "Decad3nce Dexopt: system/app already has .odex files present, exiting";
		exit;
	else
		echo "Decad3nce Dexopt: dexopt-wrapper on system applications, do not interrupt";
		for i in /system/app/*.apk
			do
				odex=`echo $i | sed -e 's/.apk/.odex/g'`
				echo "Decad3nce Dexopt: dexopt-wrapper $i $odex"
				dexopt-wrapper $i $odex
			done
fi
}

if [[ "${1}" == "FR" ]]
	then
		dexopt_core;
		exit;
else
	if [[ "${1}" == "SA" ]]
		then
			dexopt_system;
			exit;
		else
			if [[ "${1}" == "ALL" ]]
				then
					dexopt_core;
					dexopt_system;
					exit;
				else
					echo "Directions: "
					echo "This script allows you to create .odex files"
					echo "to optimize dalvik runtime"
					echo ""
					echo " How to use: "
					echo " FR	-	Framework"
					echo " SA	-	System Apps"
					echo " ALL	-	Framework/System Apps"
					echo ""
					echo ""
					echo " WARNING! WARNING! WARNING!"
					echo " DO NOT DEXOPT SYSTEM APPS THEN FRAMEWORK."
					echo " ALWAYS DEXOPT FRAMEWORKS THEN SYSTEM"
					echo " APPLICATIONS."
					echo " WRONG ORDER WILL RESULT IN ANDROID"
					echo " RUNTIME ERRORS."
					echo " WARNING! WARNING! WARNING!"
				fi
			fi
fi
	
	
